// Crtez.java

package figure;

public class Crtez extends Figura {
  private static class Elem {
    private Figura fig; private Elem preth, sled;
    private Elem (Figura fig, Elem preth, Elem sled) {
      this.fig = fig; 
      this.preth = preth; this.sled = sled; 
    }
  }
  private Elem prvi, posl;
  private double x, y, sir, vis;
  public Crtez (Boja b, double x, double y,
                double sir, double vis) { 
    super (b); 
    this.x = x; this.y = y; 
    this.sir = sir; this.vis = vis;
  }
  public double x   () { return x; }
  public double y   () { return y; }
  public double sir () { return sir; }
  public double vis () { return vis; }
  public Crtez dodaj (Figura f) {
    posl = new Elem (f, posl, null);
    if (prvi == null) prvi = posl;
      else            posl.preth.sled = posl;
    return this;
  }
  public boolean pripada (Tacka T) {
    return T.x()>=x && T.x()<=x+sir && 
           T.y()>=y && T.y()<=y+vis;
  }
  public Boja boja (Tacka T) 
    throws GTackaNePripadaFiguri {
    if (! pripada (T)) 
      throw new GTackaNePripadaFiguri (T, this);
    Tacka T2 = new Tacka (T.x()-x, T.y()-y);
    for (Elem tek=posl; tek!=null; tek=tek.preth)
      try { return tek.fig.boja (T2); }
        catch (GTackaNePripadaFiguri g) {}
    return boja (); 
  }
  private static StringBuffer 
    nivo = new StringBuffer ();
  public String toString () {
    StringBuffer nivo1 = nivo,
      nivo2 = new StringBuffer ().
              append (nivo).append ("  ");
    StringBuffer s = new StringBuffer ().
      append(super.toString("Crtez")).
      append(", dole-levo=").
      append(new Tacka(x, y)).
      append(", gore-desno=").
      append(new Tacka(x+sir,y+vis)).
      append(", figure=[\n");
      nivo = nivo2;
    for (Elem tek=prvi; tek!=null; tek=tek.sled) 
      s.append(nivo).append(tek.fig).append('\n'); 
    nivo = nivo1;
    return s.append(nivo).append(']').toString ();      
  }
} // class Crtez