// Tacka.java

package figure;
import usluge.Citaj;

public class Tacka implements Cloneable {
  private double x, y;
  public Tacka (double x, double y) 
    { this.x = x; this.y = y; }
  public Tacka () { x = y = 0; }
  public double x () { return x; }
  public double y () { return y; }
  static double d (Tacka a, Tacka b) {
    return Math.sqrt (Math.pow (a.x-b.x,2) +
                      Math.pow (a.y-b.y,2)  );
  }
  public Object clone () { 
    try { return super.clone();
    } catch (CloneNotSupportedException g) { 
      new usluge.NeocekivanaGreska (); 
      return null; 
    }
  }
  public String toString () {
    return "(" + x + ',' + y + ')';
  }
  public static Tacka citaj () { 
    return new Tacka 
      (Citaj.Double(), Citaj.Double());
  }
  public static final Tacka ORG = new Tacka ();
} // class Tacka