// CrtezObrada.java - Unutrasnji iterator koji koriscenjem
//                    spoljasnjeg CrtezIteratora primenjuje
//                    odredjenu radnju na sve Figure u Crtezu.

package figure;

public abstract class CrtezObrada {

  private Crtez crtez;
   
  public CrtezObrada(Crtez crtez) { this.crtez = crtez; }

  public final void radi() {
    Iterator iter = new CrtezIterator (crtez);
    for (iter.naZadnji(); !iter.gotovo(); iter.prethodni())
      try { if (operacija(iter.tekuci())) break; }
        catch (GNemaTekuceg g) {}
  }
   
  public abstract boolean operacija(Figura fig);

} // class CrtezObrada