// Gauss.java - Generator pseudoslucajnih brojeva sa
//              Gaussovom raspodelom.

package slucajni;

public class Gauss extends Ostali {
  
  private double sr, dev;
   
  public Gauss(double sr, double dev, Slucajni sluc) {
    super (sluc); this.sr = sr; this.dev = dev;
  }

  public Gauss(Slucajni sluc) { this (1, 1, sluc); }
   
  public double slBroj() {
    double s = 0;
    for (int i=0; i<12; i++) s += sluc.slBroj();
    return (s - 6) * dev + sr;
  }

} // class Gauss
