// SkladisteT.java - Ispitivanje sistema proizvodjac/potrosac.

import java.awt.*;
import java.awt.event.*;
import usluge.*;
import skladista.*;

class SkladisteT extends Frame {
  public SkladisteT (String[] vpar) {
    super ("Proizvodjaci/potrosaci");
    setBounds (100, 100, 300, 200);
    addWindowListener (new ProzorDogadjaj ());
    setLayout (new GridLayout (1,3));
    List lstProizvodjaci = new List ();
    TextArea tksSkladiste = new TextArea ();
    List lstPotrosaci = new List ();
    add (lstProizvodjaci);
    add (tksSkladiste);
    add (lstPotrosaci);
    int kap    = Integer.parseInt (vpar[0]), // Kapacitet skladista.
        brPro  = Integer.parseInt (vpar[1]), // Broj proizvodjaca.
        minPro = Integer.parseInt (vpar[2]), // Najkrace i najduze vreme
        maxPro = Integer.parseInt (vpar[3]), //   proizvodnje.
        brPot  = Integer.parseInt (vpar[4]), // Broj potrosaca.
        minPot = Integer.parseInt (vpar[5]), // Najkrace i najduze vreme
        maxPot = Integer.parseInt (vpar[6]); //   potrosnje.
    try {
      Skladiste skladiste = new Skladiste (kap, new Polje (tksSkladiste));
      for (int i=0; i<brPro; i++) {
        lstProizvodjaci.add ("***");
        (new Proizvodjac (skladiste, minPro, maxPro,
                          new Polje (lstProizvodjaci,i))).start ();
      }
      for (int i=0; i<brPot; i++) {
        lstPotrosaci.add ("***");
        (new Potrosac (skladiste, minPot, maxPot,
                       new Polje (lstPotrosaci, i))).start();
      }
    } catch (GPoljeNeOdgovara g) { new NeocekivanaGreska (); }
  } // Konstruktor
  private class ProzorDogadjaj extends WindowAdapter {
    public void windowClosing (WindowEvent d) {
      System.exit (1);
    }
  }
  public static void main (String[] vpar) {
    new SkladisteT (vpar).show ();
  }
} // class SkladisteT