// Boja.java

package figure;
import usluge.Citaj;

public class Boja {
  private double c, z, p;
  public Boja (double c, double z, double p) 
    throws GNeispravnaBoja {
    if (c<0 || c>1 || z<0 || z>1 || p<0 || p>1)
      throw new GNeispravnaBoja (c, z, p);
    this.c = c; this.z = z; this.p = p;
  }
  Boja () { c = z = p = 1; }
  double crvena () { return c; }
  double zelene () { return z; }
  double plava  () { return p; }
  public String toString () 
    { return "(" + c + ',' + z + ',' + p + ')'; }
  public static Boja citaj () throws GNeispravnaBoja { 
    return new Boja (Citaj.Double(), 
      Citaj.Double(), Citaj.Double());
  }
  private Boja (double c, double z, double p, int x) 
    { this.c = c; this.z = z; this.p = p; }
  public static final Boja 
    BELA   = new Boja (), 
    SIVA   = new Boja (.5, .5, .5, 0), 
    CRNA   = new Boja (0, 0, 0, 0), 
    CRVENA = new Boja (1, 0, 0, 0), 
    ZELENA = new Boja (0, 1, 0, 0), 
    PLAVA  = new Boja (0, 0, 1, 0);
} // class Boja