// Mnogougao.java

package figure;

public class Mnogougao extends Figura {
  private Tacka[] temena;
  public Mnogougao (Boja b, Tacka[] temena)
    throws GPremaloTemena {
    super (b); this.temena = temena;
    if (temena.length < 3) 
      throw new GPremaloTemena();
  }
  public Mnogougao (Tacka[] temena) 
    throws GPremaloTemena
    { this (new Boja(), temena); }
  public Tacka[]  temena () {
    Tacka[] t = new Tacka [temena.length];
    for (int i=0; i<t.length; i++)
      t[i] = (Tacka) temena[i].clone();
    return t; 
  }
  public boolean pripada (Tacka T) {
    Tacka t0 = temena[0];
    for (int i=2; i<temena.length; i++)
      if (new Trougao(t0,temena[i-1],temena[i]).pripada(T))
        return true;
    return false;
  }
  public String toString () {
    StringBuffer s = 
      new StringBuffer ().
      append(super.toString("Mnogougao")).
      append(", temena=[");
      for (int i=0; i<temena.length; i++) {
        s.append (temena[i]);
        if (i<temena.length-1) s.append(',');
      }
    return s.append(']').toString ();      
  }
} // class Mnogougao