// Semafor.java - Klasa za sinhronizaciju niti.

package matrice;

public class Semafor {

  private volatile int moze;      // Broj niti koji mogu da prodju.
  
  public Semafor (int m) { moze = m; }
  
  public synchronized void _wait () {
    while (moze <= 0) 
      try { wait (); } catch (InterruptedException g) {};
    moze--;
  }

  public synchronized void _signal () {
    moze ++; notify ();
  }
} // class Semafor