// Devijacija.java - Pracenje standardne devijacije generisanih
//                   pseudoslucajnih brojeva.

package slucajni;

public class Devijacija extends Statistika {
  
  private int n;
  private double s, d;
   
  public void azuriraj(Subjekat subj) {
    double x = ((Generator)subj).vrednost();
    s += x; d += x * x; n++;
    obavesti ();
  }
   
   public void ispocetka() { s = d = n = 0; obavesti (); }
   
   public String toString () {
     return (n!=0) ? "" + Math.sqrt(d/n-Math.pow(s/n,2)) : "";
   }

} // class Devijacija
