// Uniformni.java - Generator pseudoslucajnih brojeva sa
//                  uniformnom raspodelom.

package slucajni;

public class Uniformni implements Slucajni {

  private int klica = 314159261;
  private double min, max;
   
  public Uniformni (double min, double max) {
    this.min = min; this.max = max;
  }
  
  public Uniformni () { this (0, 1); }
  
  public Uniformni (double min, double max, int klica)
    { this (min, max); this.klica = klica; }
  
  public Uniformni (int klica) { this (0, 1); this.klica = klica; }

  public int slBrojCeli () {
    return klica = 314159261 * klica + 907633385;
  }
  
  public double slBroj () {
    return min + (max-min)*(slBrojCeli()+2147483648.)/4294967296.;
  }

} // class Uniformni
